﻿namespace UltraGridSetUpColumns
{
    using System;
    using System.Collections.Generic;
    using System.Diagnostics;
    using System.Windows.Forms;
    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        public Form1()
        {
            this.InitializeComponent();
            var data = this.GetData();
            this.ultraGrid1.DataSource = data;
        }

        private List<SOCabezaEntity> GetData()
        {
            var data = new List<SOCabezaEntity>();

            var items = new List<SOItemsEntity>();

            for (int index = 0; index < 5; index++)
            {
                items.Add(new SOItemsEntity()
                {
                    IdSales = "IdSales",
                    IdItem = "IdItem",
                    Fullname = "Fullname",
                    Name = "Name",
                    CantidadQB = index,
                    EstadoQB = index,
                    EstadoBR = index,
                    CantidadBR = index,
                    Orden = "Orden",
                });
            }

            for (int index = 0; index < 10; index++)
            {
                data.Add(new SOCabezaEntity()
                {
                    IdSales = "IdSales",
                    Fecha = DateTime.Now.AddDays(index),
                    Numero = "Numero",
                    Template = "Template",
                    NumItems = index,
                    Estado = index,
                    Procesado = DateTime.Today,
                    Idcustomer = "Idcustomer",
                    CustomerName = "CustomerName",
                    Items = items,
                });
            }

            return data;
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            // Hide the IdSales column from SOCabezaEntity parent band
            var idSalesColBand0 = e.Layout.Bands[0].Columns["IdSales"];
            idSalesColBand0.Hidden = true;

            // Change the caption of Fecha column in SOCabezaEntity parent band
            var fechaCol = e.Layout.Bands[0].Columns["Fecha"];
            fechaCol.Header.Caption = "Some Custom Text";

            // Hide the IdSales column from SOItemsEntity child band
            var idSalesColBand1 = e.Layout.Bands[1].Columns["IdSales"];
            idSalesColBand1.Hidden = true;

            Debug.WriteLine("Band 0: " + e.Layout.Bands[0].Key);
            Debug.WriteLine("Band 1: " + e.Layout.Bands[1].Key);
        }
    }
}